Page MenuHomePhabricator

Drawing in new MW tech volunteers with Hackathons, and then what
Closed, ResolvedPublic

Description

Session title

Drawing in new MW tech volunteers with Hackathons, and then what

Main topic

How to grow our technical community

Type of activity

Unconference session

Description



== 1. The problem ==
I had been running couple of Hackathons myself with University students, and the code contributions it produce duringt the Hackathon hours are just great - like there were days when we had like 5-8 patches in Gerrit in less than 8 hours. The funny thing is, right after the hackathon, people just forget about the same, and there are not any more contributions are follow up on the same. Ther are exceptional cases, but its percentage is far low than average.

This is a general problem with any technical community, but Wikimedia Foundation needs to take care of this, as:

# University students are prospective Google Summer of Code or Outreachy interns, so there is a chance for finding some long term developers there.
# The number of Google Summer of Code selects and valid applicants are reducing as per https://www.mediawiki.org/wiki/User:MaxSem/GSoC_analysis.

== 2. Expected outcome ==
I would like to talk and find ideas about:
* Running a Mediawiki code contribution drive/hackathon (from my experiences)
* Statistics of recent hackathons, how productive are they, in general.
* What happens after the hackathon
* What kind of tracking or later annoucements should be done, etc
* Should we stick on to some tracking tools or something, specially for the Hackahtons (or something like that)

== 3. Current status of the discussion ==
...

== 4. Links ==
* ...


== Proposed by ==
@01tonythomas (originally), @srishakatux and @Rfarrand (current owners)

== Preferred group size ==
15-20

== Any supplies that you would need to run the session ==
Post-its and markers

== Interested attendees (sign up below) ==

# @Qgil
# Add your name here

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 18 2016, 5:29 PM
Lucie added a subscriber: Lucie.Oct 19 2016, 5:21 PM
Gjone1 added a subscriber: Gjone1.Oct 27 2016, 4:21 PM
Tgr added a subscriber: Tgr.Oct 31 2016, 2:52 AM

Are there examples of other organizations being significantly more successful that we could learn from? In the end, becoming a community member is just a much higher level of commitment than participating at a hackathon so some level of drop-off is to be expected.

TheDJ added a subscriber: TheDJ.Oct 31 2016, 9:36 AM

Good to see this one, I was gonna propose a similar session, but I'll just add my votes to this one then :)

Are there examples of other organizations being significantly more successful that we could learn from? In the end, becoming a community member is just a much higher level of commitment than participating at a hackathon so some level of drop-off is to be expected.

I think I got something here. I just finished up with the GSoC Mentors Summit 2016, and we had a very fruitful discussion over there about the same thing, and how other communities were trying to solve this. As you know, there is no single solution, but something done by FOSSASIA caught everyones attention. Let me quote it down:

So the discusiions there was How to get students stick after GSoC, and I think its kinda similar to this one.

  1. Right after a student complete a GSoC, they ask the student to report 2 first timer issues in that project they worked and keep it open with their name written as a 'mentor'. This would make them stick back as there are chances of newbies coming in and poking them.
  2. Every student who gets selected for GSoC must organize an event - a Hackathon or something - and this is Mandatory to pass the mid-term evaluation and surprisingly - they do not fund this one. The student is supposed to find out how they can do it - and maybe hold it in a cafe or something like that - what a nice idea which we can copy.
  3. They push every student to be GCI mentors - but this is something out of hand, and very difficult for us to track down - so little hope with that one.

and they have one more very interesting thing

  • codeheat - http://codeheat.org/ -- its like a GCI without any age limitations. So if we plan this right after GSoC or maybe before GSoC, we might end up getting super good contributors. Maybe the grand prize winner can be sponsored to some WMF events (if it allow) ? I enquired with the org admin how they manage the registration and etc for the students - and it seems like they do not have any portal like GCI or GSoC in run. They have a website which accepts registrations, and then they have to request access to the Github repo or whatever which has the issues and then work on a bug and submit PR.

If we are thinking of producing something like codeheat, the issues would be:

  1. Who will manage all the fuss: If we follow the FOSSASIA model, it would just require setting up a website which would allow registrations, and then assign tasks in phabricator etc. I think it would be better to have some more functionalities like time tracking and etc in the website, and this can maybe take 1-2 week of a developers time.
  2. When should be this released: rightly before GSoC, and making sure that people who participated in such a program finds it easy to go with GSoC.

What do you guys think ?

@01tonythomas Thank you for sharing your thoughts and summary from the mentor summit! Adding a few thoughts here including the ones we talked in our meeting about the outreach programs for others to read:

  • I don't like the idea of enforcing something on learners or making mandatory as part of the summer of code contest, especially considering the fact we draw students of different levels of expertise, and they already have something challenging to accomplish. But, I do get your point of the quality of work declining in the GSOC projects. For this, we could consider encouraging weekly check-ins, or updates through IRC/ online gatherings where students could get to share their work with each other verbally.
  • Codeheat is a cool idea but seems like it would require almost the same efforts it takes to coordinate GSOC. I think it might be useful for us to think about ways we could encourage awareness about our community/ projects among students much ahead of GSOC so that students have enough understanding of the project, have already contributed in advance of the contest, and this way we can get better quality proposals.
  • Inviting recent students to be mentors for GCI/ Outreachy is something we are already doing, and very recently did this year :)
Tgr added a comment.Nov 7 2016, 8:53 AM

I does not seem like the quality of work in GSoC is declining - the ratio of successful projects was higher in 2015 and 2016 than in the previous three years. It's the number of applicants that has decreased - but then, 2013/14 seems anomalously high. And the number of successful projects did not decrease that much so maybe the mentors just got better at filtering out bad applications?

@01tonythomas Thank you for sharing your thoughts and summary from the mentor summit! Adding a few thoughts here including the ones we talked in our meeting about the outreach programs for others to read:

  • I don't like the idea of enforcing something on learners or making mandatory as part of the summer of code contest, especially considering the fact we draw students of different levels of expertise, and they already have something challenging to accomplish. But, I do get your point of the quality of work declining in the GSOC projects. For this, we could consider encouraging weekly check-ins, or updates through IRC/ online gatherings where students could get to share their work with each other verbally.

I too though the same until the GSoC mentors summit, when I heard how hard other orgs are on students :P Generally, it cannot be termed hard - but asking a student to open up two easy tasks once they finish the project do not seem that hard. To make it clear, the hackathon happens somewhere during the community bonding period, so the student isnt really started with the project phase yet. This can be enforced, and there are succesfull orgs out there doing that, but in the (3)rd one - I am not optimistic. We cannot literally push students to be GCI mentors as they are out of scope of Wikimedia once the program expires.

  • Codeheat is a cool idea but seems like it would require almost the same efforts it takes to coordinate GSOC. I think it might be useful for us to think about ways we could encourage awareness about our community/ projects among students much ahead of GSOC so that students have enough understanding of the project, have already contributed in advance of the contest, and this way we can get better quality proposals.

Heh. thats exactly what which seems almost impossible. This awareness thingy is what we could get from Hakcahtons etc, but we are talking about hackathon in a limited region (which might even need funding), and not the complete picture. For an event like GSoC, the expected participants can be anywhere from the world, and I think an online event can do more publicity than someone trying to bring in awareness. I dont even think what we can talk to them well before - like we can make them aware about GSoC or Mediawiki, but I dont think how much that would work - as we are talking about real code contribution.

Regarding the effort, it might not, as GSoC is kinda super tight contest with strict rules etc. This is where we should follow KDEs or FOSSASIA's model, and go for something which is smooth for the organizing people as well. And the effort, if it can bring in more powerfull contributors - might not be a waste at the end of the day.

  • Inviting recent students to be mentors for GCI/ Outreachy is something we are already doing, and very recently did this year :)

Yeah. that really worked this time. You are amazing! Hope they stick more.

I does not seem like the quality of work in GSoC is declining - the ratio of successful projects was higher in 2015 and 2016 than in the previous three years. It's the number of applicants that has decreased - but then, 2013/14 seems anomalously high. And the number of successful projects did not decrease that much so maybe the mentors just got better at filtering out bad applications?

I have a feeling that my thoughts were biased by what I could get while I talked to GSoC 2016 mentors during Wikimania, and later on IRC. I do not know how to prove/disprove this one though :-(

Considering the ratio, you are right @Tgr.

Qgil added a subscriber: Qgil.Nov 8 2016, 2:35 PM

It's the number of applicants that has decreased - but then, 2013/14 seems anomalously high. And the number of successful projects did not decrease that much so maybe the mentors just got better at filtering out bad applications?

In those two years we got higher numbers probably because I could work almost full time modelling what is now the "Possible Projects" model and chasing potential mentors. Then the numbers decreased because we put a higher emphasis on quality and retention, instead of just quantity. We ran into a risk of burning out mentors {{citation needed}} and we were not getting much extra out of the higher numbers.

I still think that our current numbers correspond better to what we can usefully assume at a sustainable rhythm.

The problem is still retention after the internship ends. My gut feeling at this point is that we need to improve outreach among Wikimedia editors and involved readers, since they have already some kind of interest and relationship with Wikimedia. We also need to understand better the reasons for technical volunteers to stay involved in Wikimedia (beyond the prospect of a Wikimedia job or grant), and promote those reasons.

One area to be explored is involving more actively these developers with local Wikimedians (editors). A junior developer just starting is basically nobody in our big and sometimes rough technical community. At the same time, they could be almost like rock stars in their related Wikimedia local communities, where technical skills for very basic tasks (i.e. adapting a bot or a template) are always needed.

If you had a personal connection before the internship or your build it during your GSoC/Outreach (beyond your mentors, with other peers), then just vanishing is not so simple. :)

Qgil added a comment.Nov 9 2016, 3:21 PM

(Administrative question: is this session aiming to be pre-scheduled?)

01tonythomas updated the task description. (Show Details)Nov 15 2016, 8:20 PM
Qgil removed 01tonythomas as the assignee of this task.Nov 16 2016, 10:13 AM

@01tonythomas OK, understood. I am leaving the assigned field vacant to make the situation clear. Is anyone interested in pushing this proposal forward?

Lucie added a comment.EditedNov 21 2016, 8:18 PM

We could think about merging it with the diversity proposal if no one feels responsible. I am very interested in both, but I am happy if someone with more experience feels like picking it up.

Qgil added a subscriber: Rfarrand.Nov 22 2016, 11:16 AM

Considering the amount of energy we invest in hackathons and the clear goal of retention we have about them, I think it is worth pursuing this session on its own. @Rfarrand @srishakatux what do you think?

With or without Summit session, I think this question is very relevant to Wikimedia-Hackathon-2017-Organization.

Sure, if people are interested in this as a session - lets do it. I would love to make progress here.
We could do sessions both at the Dev Summit and in Vienna or just start with Vienna. Maybe we can see how full the unconference gets - but I think there will already be a huge amount going on at the Dev Summit.

To maintain the consistency, please consider referring to the template of the following task description: https://phabricator.wikimedia.org/T149564.

srishakatux updated the task description. (Show Details)

@Rfarrand I would be happy to facilitate this unconference session with you! thank you so much @01tonythomas for initiating this. I will add more to this task description soon!

01tonythomas updated the task description. (Show Details)Dec 16 2016, 9:31 AM

I think https://lists.wikimedia.org/pipermail/wikitech-l/2016-November/086917.html might have something as well. If there is a chance for doing such a program alone, or maybe together with other communities (like we have WikiToLearn using Mediawiki), then it would be great. Also the scope, location and time for such an event to take place should be taken into consideration.

Qgil triaged this task as Medium priority.Dec 16 2016, 10:44 AM
Qgil moved this task from November to December on the Developer-Advocacy (Oct-Dec-2016) board.
Qgil updated the task description. (Show Details)Dec 20 2016, 11:05 AM
Tgr awarded a token.Dec 23 2016, 2:01 AM
Rfarrand lowered the priority of this task from Medium to Low.Jan 6 2017, 10:19 PM

moving all tasks unrelated to dev summit to low, will readjust after summit.

To the facilitator of this session: We have updated the unconference page with more instructions and faqs. Please review it in detail before the summit: https://www.mediawiki.org/wiki/Wikimedia_Developer_Summit/2017/Unconference. If there are any questions or confusions, please ask! If your session gets a spot on the schedule, we would like you to read the session guidelines in detail: https://www.mediawiki.org/wiki/Wikimedia_Developer_Summit/2017/Session_Guidelines. We would also then expect you to recruit Note-taker(s) 2(min) and 3 (max), Remote Moderator, and Advocate (optional) on the spot before the beginning of your session. Instructions about each role player's task are outlined in the guidelines. The physical version of the role cards will be available in all the session rooms! See you at the summit! :)

Qgil raised the priority of this task from Low to Medium.Jan 7 2017, 11:46 AM

moving all tasks unrelated to dev summit to low, will readjust after summit.

This is a Dev Summit task, though. :)

Rfarrand closed this task as Resolved.May 9 2017, 5:16 AM

Thanks for starting this @01tonythomas !
New efforts related to this can be found here: [https://phabricator.wikimedia.org/T163440]

I am closing this task for now as it overlaps.